Bug 1274323 - Live merge: Engine must refresh resized volume on HSM prior to starting merge
Live merge: Engine must refresh resized volume on HSM prior to starting merge
Status: CLOSED WONTFIX
Product: ovirt-engine
Classification: oVirt
Component: BLL.Storage (Show other bugs)
3.6.0
Unspecified Unspecified
unspecified Severity high (vote)
: ovirt-3.5.7
: ---
Assigned To: Greg Padgett
Kevin Alon Goldblatt
storage
:
Depends On:
Blocks: 1232481 1291569 1292129
  Show dependency treegraph
 
Reported: 2015-10-22 09:35 EDT by Adam Litke
Modified: 2016-02-10 14:12 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1291569 1292129 (view as bug list)
Environment:
Last Closed: 2015-12-16 09:41:03 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: Storage
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rule-engine: ovirt‑3.5.z+
ylavi: planning_ack+
amureini: devel_ack+
acanan: testing_ack+


Attachments (Terms of Use)
engine.log (45.26 KB, text/plain)
2015-10-22 09:36 EDT, Adam Litke
no flags Details
vdsm log from SPM host (829.09 KB, text/plain)
2015-10-22 09:37 EDT, Adam Litke
no flags Details
vdsm log from HSM host (290.48 KB, text/plain)
2015-10-22 09:37 EDT, Adam Litke
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
oVirt gerrit 47671 master MERGED core, vdsbroker: Refresh volume after extension during Live Merge Never
oVirt gerrit 50470 ovirt-engine-3.6 MERGED core, vdsbroker: Refresh volume after extension during Live Merge Never
oVirt gerrit 50474 ovirt-engine-3.5 MERGED core, vdsbroker: Refresh volume after extension during Live Merge Never

  None (edit)
Description Adam Litke 2015-10-22 09:35:12 EDT
Description of problem:

If a drive was enlarged after creation of a snapshot then the volume associated with the snapshot will be smaller than the currently active volume.  If the snapshot volume is also on preallocated block storage then engine needs to manually enlarge the snapshot volume prior to starting a live merge.

Today, engine issues the extendVolumeSize call to SPM but it does not notify the host running the VM (HSM host) that the volume has been resized.  This means that when a VM is running on a non-SPM host the resize won't be picked up by qemu and the merge will fail.


Version-Release number of selected component (if applicable):
ovirt-engine-4.0.0-0.0.master.20151020161541.git37557f3.el7.centos.noarch

How reproducible:
Always

Steps to Reproduce:
1. Start a VM on a non-SPM host with a preallocated block disk
2. Create a snapshot involving the disk
3. Enlarge the disk by 1GB
4. Delete the snapshot

Actual results:
The merge fails with an error like the following on the HSM host:

libvirtError: internal error: unable to execute QEMU command 'block-commit': Top image /rhev/data-center/108151fa-1c40-4ee3-bae0-d91d0e56f44d/2276ca67-cdff-4bde-b437-446fc2e92a46/images/65ade35f-deed-4e0d-8a73-7c98c80fb661/b97c3c80-f781-4b51-bb79-5929fd9f3cf8 is larger than base image /rhev/data-center/108151fa-1c40-4ee3-bae0-d91d0e56f44d/2276ca67-cdff-4bde-b437-446fc2e92a46/images/65ade35f-deed-4e0d-8a73-7c98c80fb661/71bc1e19-e392-4121-9c2f-896d7402db22, and resize of base image failed: Invalid argument

Expected results:

The snapshot should be removed successfully.

Additional info:
Comment 1 Adam Litke 2015-10-22 09:36 EDT
Created attachment 1085521 [details]
engine.log
Comment 2 Adam Litke 2015-10-22 09:37 EDT
Created attachment 1085522 [details]
vdsm log from SPM host
Comment 3 Adam Litke 2015-10-22 09:37 EDT
Created attachment 1085524 [details]
vdsm log from HSM host
Comment 4 Adam Litke 2015-10-22 09:38:46 EDT
I believe the proper way to fix this is for engine to issue a diskSizeExtend to the HSM host as discussed in the Feature Page for online disk resize:

http://www.ovirt.org/Features/Online_Virtual_Drive_Resize#Detailed_Description
Comment 5 Yaniv Lavi 2015-10-29 08:51:23 EDT
In oVirt testing is done on single release by default. Therefore I'm removing the 4.0 flag. If you think this bug must be tested in 4.0 as well, please re-add the flag. Please note we might not have testing resources to handle the 4.0 clone.
Comment 6 Allon Mureinik 2015-12-16 09:41:03 EST
Patch was merged to the upstream ovirt-3.5 branch, but we currently aren't planning to have a 3.5.7 build.
Closing.

Note You need to log in before you can comment on or make changes to this bug.